/*
Programmname	: queue	
Autor			: Scholtes, Matthias
Datum		: 03.01.2008
Version		: 2.0
Beschreibung	: Programm zur Verwaltung einer queue innerhalb eines Arrays
				2.0: Neuimplementierung mittels OOP
Build			: 	g++ -c -Wall -pedantic main.cpp
				g++ -c -Wall -pedantic ausgabe.cpp
				g++ -c -Wall -pedantic queue.cpp
				g++ -o queue.e main.o queue.o ausgabe.o
Rückgabewerte	: 0 - Programm erfolgreich ausgeführt
*/

/*
Dateiname		: main.cpp
*/

#include "queue.h"
#include "main.h"

#include<iostream>
using namespace std;

int main()
{
	ausgabe::clearShell();
	
	cout << "Geben sie die maximale Groesse des Arrays ein: ";
	int size;
	cin >> size;
	
	ausgabe::clearShell();
	
	//Erstellen des Objektes q
	queue* q = new queue(size);

	hauptprogramm::start(q);
	
	return 0;
}

void hauptprogramm::start(queue* q)
{
	cout << "--- Letzte durchgefuehrte Operation:" << endl;
	cout << "	Queue initialisiert" << endl;
	ausgabe::leerzeilen(3);

	/*Variable zur Speicherung der Benutzerauswahl bzgl der durchzufuehrenden Folgeoperation
		wird mit ' ' initialisiert um einen ersten Schleifendurchlauf zu ermoeglichen*/
	char operationsAuswahl = ' ';
	//Wiederholung bis Benutzer 'b' eingibt
	while (operationsAuswahl != 'b')
	{
		//Anzeige der aktuellen Queue
		cout << "--- Aktuelle Queue:" << endl;
		q->ausgabeArray();
		ausgabe::leerzeilen(5);
	
		//Anzeige der zur Verfueguing stehenden Folgeoperationen
		cout << "--- Waehlen sie die naechste durchzufuehrende Operation:" << endl;
		cout << "Enqueue		'e'" << endl;
		cout << "Dequeue		'd'" << endl;
		ausgabe::leerzeilen(1);
		cout << "Beenden		'b'" << endl;
		ausgabe::leerzeilen(1);
		cout << "Ihre Auswahl: ";
		//Eingabe des Kuerzels fuer die durchzufuehrende Operation
		cin >> operationsAuswahl;
		
		ausgabe::clearShell();
		
		//Fallunterscheidung der Benutzereingabe
		switch(operationsAuswahl)
		{
			case 'e':
			{
				q->callEnqueue();
			}
			break;
			case 'd':
			{
				q->callDequeue();
			}
			break;
			case 'b':
			{
				cout << "Programm wird beendet" << endl;
				ausgabe::leerzeilen(1);
			}
			break;
			default:
			{
				operationsAuswahl = 'b';
				cout << "Ungueltige Auswahl" << endl;
				cout << "Programm wird beendet" << endl;
				ausgabe::leerzeilen(1);
			}
			break;
		}
		
	}

	q->~queue();
}

//Gibt eine gewaehlte Anzahl von Zeilenumbruechen aus
void ausgabe::leerzeilen(int anzahl)
{
	for (int i = 0; i < anzahl; i++)
	{
		cout << endl;
	}
}

//Loescht die bisherigen Inhalte der Shell
void ausgabe::clearShell()
{
	// system("clear");
	cout << "\033[2J" << flush;
}

